unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids;

type
  TForm1 = class(TForm)
    StringGridXc: TStringGrid;
    StringGridA: TStringGrid;
    StringGridX: TStringGrid;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    StringGridB: TStringGrid;
    StaticText3: TStaticText;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    procedure Nastaveni(Sender: TObject);
    procedure ZmenitPocet(Sender: TObject);
    procedure ProstaIterace(Sender: TObject);
    procedure Zrychlena(Sender: TObject);
    procedure Reset(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Const Max = 10;
var   a     : array [1..Max,1..Max] of double;
      x,xc,b: array [1..Max]        of double;
      n,CisloIter:Integer;

Procedure NacteniZadani;
var i,j,Chyba:Integer;
    Vypis    :String;
begin
 for i:=1 to n do
   begin
    Str(x[i]:7:6,Vypis);
    Form1.StringGridX.Cells[0,i-1]:=Vypis;
    Form1.StringGridXc.Cells[0,i-1]:='';
   end;
 For i:=1 to n do
   For j:=1 to n do
     begin
       Val(Form1.StringGridA.Cells[j-1,i-1],a[i,j],Chyba);
     end;
 For i:=1 to n do
     begin
       Val(Form1.StringGridb.Cells[0,i-1],b[i],Chyba);
     end;
end;

procedure TForm1.Nastaveni(Sender: TObject);
var i,j  :Integer;
    Vypis:String;
begin
 n:=3;
 a[1,1]:=-0.4;a[1,2]:=-0.16; a[1,3]:=-0.56; b[1]:=1.8;
 a[2,1]:=0.23;a[2,2]:=0.1; a[2,3]:= 0.18; b[2]:=-1.31;
 a[3,1]:=0.375;a[3,2]:=0.125; a[3,3]:=0.104; b[3]:=0.645833;
 for i:=1 to n do x[i]:=0;
 xc:=x;
 With StringGridA do begin
                       ColCount:=n;RowCount:=n;
                       for i:=1 to n do
                         For j:=1 to n do
                         begin
                           Str(a[i,j]:7:6,Vypis);
                           Cells[j-1,i-1]:=Vypis;
                         end;
                     end;
 With StringGridX do begin
                       RowCount:=n;
                       for i:=1 to n do
                         begin
                           Str(x[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;
                     end;
 With StringGridb do begin
                       RowCount:=n;
                       for i:=1 to n do
                         begin
                           Str(b[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;
                     end;
 StringGridXc.RowCount:=3;
end;

procedure TForm1.ZmenitPocet(Sender: TObject);
begin
 n:=SpinEdit1.Value;
 With StringGridA do begin
                       ColCount:=n;RowCount:=n;
                     end;
 StringGridX.RowCount:=n;
 StringGridXc.RowCount:=n;
 StringGridB.RowCount:=n;
end;

procedure TForm1.ProstaIterace(Sender: TObject);
var i,j:Integer;
    Vypis:String;

begin
  NacteniZadani;
  for i:=1 to n do
    begin
    xc[i]:=0;
    for j:=1 to n do xc[i]:=xc[i]+a[i,j]*x[j];
    xc[i]:=xc[i]+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
  x:=xc;
  SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Zrychlena(Sender: TObject);
var i,j:Integer;
    Vypis:String;
    Suma :Double;
begin
  NacteniZadani;
  for i:=1 to n do
    begin
    Suma:=0;
    for j:=1 to n do
           Suma:=Suma+a[i,j]*xc[j];
    xc[i]:=Suma+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
   x:=xc;
   SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Reset(Sender: TObject);
var i:Integer;
begin
  for i:=1 to n do x[i]:=0;
  xc:=x;
  NacteniZadani;
  SpinEdit2.Value:=0;
end;

end.
