unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids;

type
  TForm1 = class(TForm)
    StringGridXc: TStringGrid;
    StringGridA: TStringGrid;
    StringGridX: TStringGrid;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    StringGridB: TStringGrid;
    StaticText3: TStaticText;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    Button4: TButton;
    procedure Nastaveni(Sender: TObject);
    procedure ZmenitPocet(Sender: TObject);
    procedure ProstaIterace(Sender: TObject);
    procedure Zrychlena(Sender: TObject);
    procedure Reset(Sender: TObject);
    procedure Button4Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Const Max = 10;
var   a     : array [1..Max,1..Max] of double;
      x,xc,b: array [1..Max]        of double;
      n,CisloIter:Integer;

Procedure NacteniZadani;
var i,j,Chyba:Integer;
    Vypis    :String;
begin
 for i:=1 to n do
   begin
    Str(x[i]:7:6,Vypis);
    Form1.StringGridX.Cells[0,i-1]:=Vypis;
    Form1.StringGridXc.Cells[0,i-1]:='';
   end;
   For i:=1 to n do
   For j:=1 to n do
     begin
       Val(Form1.StringGridA.Cells[j-1,i-1],a[i,j],Chyba);
     end;
 For i:=1 to n do
     begin
       Val(Form1.StringGridb.Cells[0,i-1],b[i],Chyba);
     end;
end;

procedure TForm1.Nastaveni(Sender: TObject);
var i,j  :Integer;
    Vypis:String;
begin
 n:=3;
 StringGridA.Cells[0,0]:='0';      StringGridA.Cells[1,0]:='-0.4/3.5';StringGridA.Cells[2,0]:='-1.4/3.5';
 StringGridA.Cells[0,1]:='2.3/9.0';StringGridA.Cells[1,1]:=       '0';StringGridA.Cells[2,1]:= '1.8/9.0';
 StringGridA.Cells[0,2]:='3.6/8.6';StringGridA.Cells[1,2]:='1.2/8.6';StringGridA.Cells[2,2]:=       '0';

 StringGridB.Cells[0,0]:='4.5/3.5';StringGridB.Cells[0,1]:='-13.1/9.0';StringGridB.Cells[0,2]:='6.2/8.6';

 a[1,1]:=0;a[1,2]:=-0.1143; a[1,3]:=-0.4; b[1]:=1.2857;
 a[2,1]:=0.2555555;a[2,2]:=0; a[2,3]:= 0.2; b[2]:=-1.455555;
 a[3,1]:=0.4186;a[3,2]:=0.1395; a[3,3]:=0; b[3]:=0.7209;
 for i:=1 to n do x[i]:=0;
 xc:=x;
{ With StringGridA do begin
                       ColCount:=n;RowCount:=n;
                       for i:=1 to n do
                         For j:=1 to n do
                         begin
                           Str(a[i,j]:7:6,Vypis);
                           Cells[j-1,i-1]:=Vypis;
                         end;
                     end;
 With StringGridX do begin
                       RowCount:=n;
                       for i:=1 to n do
                         begin
                           Str(x[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;
                     end;
 With StringGridb do begin
                       RowCount:=n;
                       for i:=1 to n do
                         begin
                           Str(b[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;
                     end;}
 StringGridXc.RowCount:=3;
end;

procedure TForm1.ZmenitPocet(Sender: TObject);
begin
 n:=SpinEdit1.Value;
 With StringGridA do begin
                       ColCount:=n;RowCount:=n;
                     end;
 StringGridX.RowCount:=n;
 StringGridXc.RowCount:=n;
 StringGridB.RowCount:=n;
end;

procedure TForm1.ProstaIterace(Sender: TObject);
var i,j:Integer;
    Vypis:String;

begin
  NacteniZadani;
  for i:=1 to n do
    begin
    xc[i]:=0;
    for j:=1 to n do xc[i]:=xc[i]+a[i,j]*x[j];
    xc[i]:=xc[i]+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
  x:=xc;
  SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Zrychlena(Sender: TObject);
var i,j:Integer;
    Vypis:String;
    Suma :Double;
begin
  NacteniZadani;
  for i:=1 to n do
    begin
    Suma:=0;
    for j:=1 to n do
           Suma:=Suma+a[i,j]*xc[j];
    xc[i]:=Suma+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
   x:=xc;
   SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Reset(Sender: TObject);
var i:Integer;
begin
  for i:=1 to n do x[i]:=0;
  xc:=x;
  NacteniZadani;
  SpinEdit2.Value:=0;
end;

procedure TForm1.Button4Click(Sender: TObject);
Type TTerm = record
               Character:Char;
               Value    :Double;
             end;
     TExpression = array [0..255] of TTerm;


Const Max     =255;                                    {maximalni dlka etzce}
      NoOfFunct=14;
      Digits  =['0'..'9','.'];
      BinOper =['^','*','/','+','-'];                        {binrn opertory}
      UnOper  =[#199..#211];                                  {unrn opertory}
      Functions :array [1..NoOfFunct] of string =
                    ('E','ABS','SIN','SQR','SQRT','COS','ARCTAN','ARCSIN','ARCCOS',
                   'EXP','LN','TAN','FA','PI');
      Letters = ['E','A','B','S','I','N','Q','R','T','C','O','K','N',
                                     'X','P','L','F','Y','Z'];
      Variables = ['K','N','R','S','T','X','Y','Z'];
      PractZero  = 1e-15;

Var Expression            :TExpression;
    {Promnn pro chybov hlen}
    ErrorReport           :String;
    i,j                   :Integer;
    Vypis                 :String;
    x,y,t,r,s,z,k,fi      :double;

Function Prvek(Zapis:String;i:Integer; var Hodnota:Double; var Znak:Char;var PocetZnaku:Integer):Boolean;
//Funkce pro ten zpisu po prvcch.
//vrac true, pokud se jet etl znak
//vrac znak "$" pokud se etlo slo

var j,Code    :Integer;
begin
    if i>Length(zapis)
          then Prvek:=False
          else begin
                 Prvek:=True;
                 if Zapis[i] in digits
                 then begin
                           Znak:='$'; {na vstupu je slo}
                           j:=i;
                           Repeat
                             inc(i);
                             if Zapis[i]='E' then inc(i);
                             if ((Zapis[i]='+') or (Zapis[i]='-')) and (Zapis[pred(i)]='E')
                                             then inc(i);
                           Until not(Zapis[i] in Digits);
                           PocetZnaku:=i-j;
                           Val(Copy(Zapis,j,i-j),Hodnota,Code);
                           if Code>0 then begin Znak:='#';exit;end;
                        end
                    else Znak:=Zapis[i]; {Precte jiny znak}
               end;
end;

//Pomocn funkce pro vyslen etezce

Function FunctionReplacement(Vstup:String):String;
// funkce zamuje zpisy matematickch funkc za jednopismenove priznaky
var i,j,k,Left,Right :Integer;
    Vystup,Vypis     :String;
begin
  for i:=1 to length(Vstup) do Vstup[i]:=UpCase(Vstup[i]);
  i:=0;
  Repeat
   inc(i);
   if Vstup[i]=',' then Vstup[i]:='.';
   if not (Vstup[i] in Letters+BinOper+Digits+['(',')']) then
     begin
       FunctionReplacement:='Chybny vyraz';exit;
     end;
  until i=length(Vstup);

  Left:=0;Right:=0;

  i:=0;
  Repeat
     inc(i);
     Case Vstup[i] of
    '.'                 : if (not (Vstup[pred(i)] in Digits)) or
                             (not (Vstup[succ(i)] in Digits)) then
                           begin
                              FunctionReplacement:='Chybny vyraz';exit;
                           end;
    '('                 :inc(Left);
    ')'                 :inc(Right);
    '^','*','/','+','-' :if (Vstup[succ(i)] in binoper+[')']) then
                         begin
                           FunctionReplacement:='Chybny vyraz';exit;
                         end;
    'A','E','F','S','N','R','T','L','C',
    'K','X','P','Y','Z':begin
                          Vypis:=Vstup[i];
                          j:=succ(i);
                          While Vstup[j] in Letters do
                            begin Vypis:=Vypis+Vstup[j];inc(j);end;
                          if j=succ(i)
                            then begin
                                  if (not (Vstup[i] in Variables))
                                   then
                                    begin
                                      FunctionReplacement:='Chybny vyraz';exit;
                                    end;
                                 end
                            else begin
                             k:=0;
                             Repeat
                               inc(k);
                             until (Vypis=Functions[k]) or (k=pred(NoOfFunct));
                             if Vypis<>'PI' then
                             if (Vypis<>Functions[k]) or (Vstup[j]<>'(')
                             then begin
                                    FunctionReplacement:='Chybny vyraz';exit;
                                  end
                          end;
                          i:=pred(j);
                         end;
      '0'..'9'         :begin
                        end;
      else begin
            FunctionReplacement:='Chybny vyraz';exit;
           end;
    end;
 until i=Length(Vstup);
 if Left<>Right then
      begin
       FunctionReplacement:='Chybny vyraz';exit;
     end;

  Vystup:='';
  i:=1;
  Repeat
       Case Vstup[i] of
        {funkce}
       '-':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup + #199  {unrn minus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       '+':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup          {unrn plus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       'S': Case Vstup[i+2] of
               'N':begin Vystup:=Vystup + #200;                          {sinus}
                         i:=i+3;
                   end;
               'R':begin
                   if Vstup[i+3]='T'
                   then begin Vystup:=Vystup + #207;i:=i+4;end {druha odmocnina}
                   else begin Vystup:=Vystup + #206;i:=i+3;end   {druha mocnina}
                   end;
               else begin Vystup:=Vystup+'S';inc(i);end;            {promnn S}
               end;
       'C':if Vstup[succ(i)]='O'
               then begin Vystup:=Vystup + #201;i:=i+3;end;            {cosinus}
       'A':Case Vstup[i+3] of
                'T':begin Vystup:=Vystup + #204;i:=i+6;end;             {arctan}
                'S':begin Vystup:=Vystup + #209;i:=i+6;end;             {arcsin}
                'C':begin Vystup:=Vystup + #210;i:=i+6;end              {arccos}
                 else begin Vystup:=Vystup + #208;i:=i+3;end;              {abs}
               end;
       'E':begin Vystup:=Vystup + #202;i:=i+3;end;                         {exp}
       'L':begin Vystup:=Vystup + #203;i:=i+2;end;                          {ln}
       'T':if Vstup[succ(i)]='A'
             then begin Vystup:=Vystup + #205;i:=i+3;end                   {tan}
             else begin Vystup:=Vystup+'T';inc(i);end;              {promnn T}
       'F':begin Vystup:=Vystup + #211;i:=i+2;end;              {fa - faktoril}
       'P':begin Vystup:=Vystup+'P';i:=i+2;end;                  {Konstanta pi}
       {Promnn}
       'X':begin Vystup:=Vystup+'X';inc(i);end;                     {promnn X}
       'Y':begin Vystup:=Vystup+'Y';inc(i);end;                     {promnn Y}
       'Z':begin Vystup:=Vystup+'Z';inc(i);end;                     {promnn Z}
       'R':begin Vystup:=Vystup+'R';inc(i);end;                     {promnn R}
       'N':begin Vystup:=Vystup+'N';inc(i);end;                     {promnn N}
       'K':begin Vystup:=Vystup+'K';inc(i);end;                     {promnn K}
        else begin Vystup:=Vystup + Vstup[i];inc(i);end
       end;                                                               {Case}
  Until i>Length(Vstup);
  FunctionReplacement:=Vystup;
end;

Function PreCalc(Vstup:String;var Errorreport:String):TExpression;
Const Max = 255;                                     {maximalni pocet operatoru}
      NotInit = 0;                                    {neinicializovana hodnota}
var   Zasobnik  : TExpression;                               {Pracovni zasobnik}
      W         : 0..Max;                                     {Vrchol zasobniku}
      H         : Double;                                     {hodnoty operand}
      Z         : Char;                                         {znak na vstupu}
      Pokracovat: Boolean;
      i,j,Pocet : Integer;
      VypisCisla:String;
      Vystup    :TExpression;
      Term      :TTerm;
begin
  VypisCisla:=Vstup;
  Vstup:=FunctionReplacement(Vstup);
  if (vstup='Chybny vyraz') or
     (vstup='Chybne cislo') then
     begin
       ErrorReport:=Vstup;
       exit;
     end;
  For j:=1 to max do
      With Vystup[j] do begin Value:=NotInit;Character:='%';end;
  w:=0;i:=1;j:=0;
  Pokracovat:=Prvek(Vstup,i,H,Z,Pocet);
  While Pokracovat do
  begin
   Case Z of
   '$':With Vystup[j] do
       begin                                                {na vstupu je cislo}
             Value:=H;Character:='$';
             inc(j);
             i:=i+Pocet;
       end;
   '#':begin ErrorReport:='Chybne cislo';                         {chybne cislo}
             exit;
       end;
   'P':With Vystup[j] do
       begin                                                   {na vstupu je pi}
             Value:=Pi;Character:='$';inc(j);inc(i);
       end;
   'K','N','R','S','T','X','Y','Z':
       With Vystup[j] do
       begin                                             {na vstupu je promenna}
             Value:=NotInit;Character:=Z;inc(j);inc(i);
       end;
   '(':begin                                              {zavorku do zasobniku}
             inc(W);
             Term.Character:='(';Term.Value:=NotInit;
             Zasobnik[w]:=Term;inc(i);
       end;
   ')':begin                                  {z vrcholu zasobniku az k zavorce}
         while (w>0) and (Zasobnik[w].Character<>'(') do
           begin  Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
           if w=0 then begin Errorreport:='Chybny vyraz';exit;end
                  else dec(w);                                 {zruseni zavorky}
         inc(i);
       end;
 ' ' :inc(i);
 #200..#211:                    {operatory nejvyssi priority - ven ze zasobniku}
       begin
         while (w>0) and (Zasobnik[w].Character in [#200..#211]) do
             begin
                   Vystup[j]:=Zasobnik[w];
                   inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                          {znak do zasobniku}
           inc(i);
       end;

 '^' :  begin                                       {mocnina - ven ze zasobniku}
           while
           (w>0) and ((Zasobnik[w].Character='^') or (Zasobnik[w].Character in [#200..#211])) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);
             Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;

 '/','*':begin                     {operatory nizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#200..#211,'*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
  #199:  begin                                                   {unarni minus}
           while (w>0) and (Zasobnik[w].Character in [#200..#211,'+','-','*','/','^']) do
           begin
             Vystup[j]:=Zasobnik[w];
             inc(j);dec(w)
           end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                             {znak do zasobniku}
             inc(i);
           end;
 '+','-':begin                  {operatory nejnizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#199..#211,'+','-','*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
 
     end; {Case}
    Pokracovat:=Prvek(Vstup,i,H,Z,Pocet);
  end;
  While (w>0) and (Zasobnik[w].Character<>'(') do
       begin                              {vyprazdnit pripadny zbytek zasobniku}
        Vystup[j]:=Zasobnik[w];inc(j);dec(w);
       end;
  PreCalc:=Vystup;
  if w>0 then Errorreport:='Chybny vyraz'
         else Errorreport:='';
end;                                                       {Procedure PreExpres}

Function PostCalc(Vstup:TExpression;var ErrorReport:String):Double;
var   Zasobnik,ZZZ  : TExpression;                 {zsobnk na hodnoty}
      i,w       : Integer;
      H,H1,H2   :Double;

Function Faktorial(N:LongInt):LongInt;
begin
   if n>1 then Faktorial:=n*Faktorial(pred(n))
          else Faktorial:=1;
end;

Function Mocnina(Zaklad:Double;Exponent:LongInt):Double;
var i:LongInt;
    Moc:Double;
begin
  Moc:=1;
  for i:=1 to abs(Exponent) do Moc:=Moc*Zaklad;
  if Exponent<0 then Moc:=1/Moc;
  Mocnina:=Moc;
end;

begin
  if (ErrorReport='Chybny vyraz')
      or (ErrorReport='Chybne cislo') then Exit;
  ErrorReport:='';
  w:=-1;i:=0;
  While (Vstup[i].Character<>'%') do
  begin
    Case Vstup[i].Character of
   '$':begin inc(w);                                        {na vstupu je cislo}
             Zasobnik[w]:=Vstup[i];
             inc(i);
       end;
   'K','N','R','S','T','X','Y','Z':                      {na vstupu je promenna}
       begin
            inc(w);
            Case Vstup[i].Character of
            'K': Vstup[i].Value:=K;
            'N': Vstup[i].Value:=N;
            'R': Vstup[i].Value:=R;
            'S': Vstup[i].Value:=S;
            'T': Vstup[i].Value:=T;
            'X': Vstup[i].Value:=X;
            'Y': Vstup[i].Value:=Y;
            'Z': Vstup[i].Value:=Z;
            end;
           Zasobnik[w]:=Vstup[i];
           inc(i);
       end;
     '^','/','*', '+','-':             {binrn opertory}
        begin
          H1:=Zasobnik[w].Value;
          dec(w);
          H2:=Zasobnik[w].Value;
           Case Vstup[i].Character of
            '^':begin
                 {H2^H1}
                 if (Abs(H2)<PractZero) and (H1<0) then
                    begin
                      ErrorReport:='Neppustn zklad reln mocniny';
                      exit;
                    end
                 else
                 if (H1<0) and (H1=Round(h1))
                          then Zasobnik[w].Value:=Mocnina(H2,Round(H1))
                     else if H1=Round(h1)
                        then Zasobnik[w].Value:=Mocnina(H2,Round(H1))
                          else if h2>PractZero
                              then Zasobnik[w].Value:=exp(H1*ln(H2))
                              else begin
                                    ErrorReport:='Neppustn zklad reln mocniny';
                                    exit;
                                   end;
                end;
            '/':begin
                  if Abs(H1)<PractZero
                   then begin
                          ErrorReport:='Dlen nulou';
                          exit;
                        end
                        else Zasobnik[w].Value:=H2 /   H1;
                end;
            '*':Zasobnik[w].Value:=H2 *   H1;
            '+':Zasobnik[w].Value:=H2 +   H1;
            '-':Zasobnik[w].Value:=H2 -   H1;
            end;
            inc(i);
          end;
                                           {funkce}
        #199:begin
              inc(i);Zasobnik[w].Value:=-Zasobnik[w].Value;      {unrn minus}
             end;
        #200:begin
              inc(i);Zasobnik[w].Value:=sin(Zasobnik[w].Value);          {sinus}
             end;
        #201:begin
              inc(i);Zasobnik[w].Value:=cos(Zasobnik[w].Value);        {cosinus}
             end;
        #202:begin
              inc(i);Zasobnik[w].Value:=exp(Zasobnik[w].Value);            {exp}
             end;
        #203:begin
              inc(i);
              if Zasobnik[w].Value>PractZero
                          then Zasobnik[w].Value:=ln(Zasobnik[w].Value)     {ln}
                          else begin
                                ErrorReport:='Neppustn argument logaritmu';
                                exit;
                               end;
             end;
        #204:begin
              inc(i);Zasobnik[w].Value:=arctan(Zasobnik[w].Value);      {arctan}
             end;
        #205:begin
              inc(i);                                                  {tangens}
              if abs(cos(Zasobnik[w].Value))>PractZero
                            then Zasobnik[w].Value:=sin(Zasobnik[w].Value)/cos(Zasobnik[w].Value)
                            else begin
                                  ErrorReport:='Nedefinovan tangens';
                                  exit;
                                 end;
             end;
        #206:begin
              inc(i);Zasobnik[w].Value:=sqr(Zasobnik[w].Value);{druh mocnina}
             end;
        #207:begin
              inc(i);                                          {druh odmocnina}
              if Zasobnik[w].Value>=0
                      then Zasobnik[w].Value:=sqrt(Zasobnik[w].Value)
                      else begin
                           ErrorReport:='Zporn argument odmocniny';
                           exit;
                           end;
             end;
        #208:begin
              inc(i);Zasobnik[w].Value:=Abs(Zasobnik[w].Value);{absolutn hodnota}
             end;
        #209:begin                                                 {arcus sinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=
                 arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=-pi/2
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=pi/2
                        else begin
                              ErrorReport:='Neppustn argument arcsin';
                              exit;
                             end;
             end;
        #210:begin                                               {arcus cosinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=pi/2-arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=pi
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=0
                        else begin
                              ErrorReport:='Neppustn argument arccos';
                              exit;
                             end;
             end;
        #211:begin                                                   {faktoril}
               inc(i);
               if (Zasobnik[w].Value>=0) and (Round(Zasobnik[w].Value)=Zasobnik[w].Value)
                  then Zasobnik[w].Value:=Faktorial(Round(Zasobnik[w].Value))
                  else begin
                        ErrorReport:='Neppustn argument faktorilu';
                        exit;
                       end;
             end;
         end;                                                           {Case Z}
        end;
  if w>0 then ErrorReport:='Chybn vraz';
  PostCalc:=Zasobnik[w].Value;
end;                                                                {PostExpres}

begin
   For i:=1 to n do
     For j:=1 to n do
     begin
       Expression:=PreCalc(StringGridA.Cells[j-1,i-1],ErrorReport);
       if ErrorReport<>'' then begin
                                 ShowMessage('Chybn zadn');
                                 exit;
                               end;
       a[i,j]:=PostCalc(Expression,ErrorReport);
       if ErrorReport<>'' then begin
                                 ShowMessage('Chybn zadn');
                                 exit;
                               end;
       Str(a[i,j]:7:6,Vypis);
       StringGridA.Cells[j-1,i-1]:=Vypis;
     end;
   For i:=1 to n do
    begin
       Expression:=PreCalc(StringGridB.Cells[0,i-1],ErrorReport);
       if ErrorReport<>'' then begin
                                 ShowMessage('Chybn zadn');
                                 exit;
                               end;
       b[i]:=PostCalc(Expression,ErrorReport);
       if ErrorReport<>'' then begin
                                 ShowMessage('Chybn zadn');
                                 exit;
                               end;
       Str(b[i]:7:6,Vypis);
       StringGridB.Cells[0,i-1]:=Vypis;
     end;

end;

end.
