unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids;

type
  TForm1 = class(TForm)
    StringGridXc: TStringGrid;
    StringGridA: TStringGrid;
    StringGridX: TStringGrid;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    StringGridB: TStringGrid;
    StaticText3: TStaticText;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    StringGridPuvA: TStringGrid;
    StringGridPuvB: TStringGrid;
    Label3: TLabel;
    Label4: TLabel;
    Button4: TButton;
    Button5: TButton;
    Label5: TLabel;
    procedure Nastaveni(Sender: TObject);
    procedure ZmenitPocet(Sender: TObject);
    procedure ProstaIterace(Sender: TObject);
    procedure Zrychlena(Sender: TObject);
    procedure Reset(Sender: TObject);
    procedure PuvSoust(Sender: TObject);
    procedure Transponovana(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Const Max = 10;
var   PuvA,TranspA,A     : array [1..Max,1..Max] of double;
      x,xc,PuvB,TranspB,b: array [1..Max]        of double;
      n,CisloIter:Integer;

Procedure NacteniZadani;
var i,j,Chyba:Integer;
    Vypis    :String;
begin
 for i:=1 to n do
   begin
    Str(x[i]:7:6,Vypis);
    Form1.StringGridX.Cells[0,i-1]:=Vypis;
    Form1.StringGridXc.Cells[0,i-1]:='';
   end;
 For i:=1 to n do
   For j:=1 to n do
     begin
       Val(Form1.StringGridA.Cells[j-1,i-1],a[i,j],Chyba);
     end;
 For i:=1 to n do
     begin
       Val(Form1.StringGridb.Cells[0,i-1],b[i],Chyba);
     end;
end;

procedure TForm1.Nastaveni(Sender: TObject);
var i,j  :Integer;
    Vypis:String;
begin
 n:=3;
 puva[1,1]:=3.5;puva[1,2]:=0.4;  puva[1,3]:=1.4;  puvb[1]:=4.5;
 puva[2,1]:=2.3;puva[2,2]:=-9.0; puva[2,3]:= 1.8; puvb[2]:=13.1;
 puva[3,1]:=3.6;puva[3,2]:=1.2;  puva[3,3]:=-8.6; puvb[3]:=-6.2;
 for i:=1 to n do x[i]:=0;
 xc:=x;
 With StringGridPuvA do begin
                       ColCount:=n;RowCount:=n;
                       for i:=1 to n do
                         For j:=1 to n do
                         begin
                           Str(puva[i,j]:7:6,Vypis);
                           Cells[j-1,i-1]:=Vypis;
                         end;
                     end;
 With StringGridX do begin
                       RowCount:=n;
                     {  for i:=1 to n do
                         begin
                           Str(x[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;}
                     end;
 With StringGridPuvb do begin
                       RowCount:=n;
                       for i:=1 to n do
                         begin
                           Str(puvb[i]:7:6,Vypis);
                           Cells[0,i-1]:=Vypis;
                         end;
                     end;
 StringGridXc.RowCount:=3;
end;

procedure TForm1.ZmenitPocet(Sender: TObject);
begin
 n:=SpinEdit1.Value;
 With StringGridA do begin
                       ColCount:=n;RowCount:=n;
                     end;
 StringGridX.RowCount:=n;
 StringGridXc.RowCount:=n;
 StringGridB.RowCount:=n;
end;

procedure TForm1.ProstaIterace(Sender: TObject);
var i,j:Integer;
    Vypis:String;

begin
  NacteniZadani;
  for i:=1 to n do
    begin
    xc[i]:=0;
    for j:=1 to n do xc[i]:=xc[i]+a[i,j]*x[j];
    xc[i]:=xc[i]+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
  x:=xc;
  SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Zrychlena(Sender: TObject);
var i,j:Integer;
    Vypis:String;
    Suma :Double;
begin
  NacteniZadani;
  for i:=1 to n do
    begin
    Suma:=0;
    for j:=1 to n do
           Suma:=Suma+a[i,j]*xc[j];
    xc[i]:=Suma+b[i];
    end;
  for i:=1 to n do
   begin
    Str(xc[i]:7:6,Vypis);
    StringGridXc.Cells[0,i-1]:=Vypis;
   end;
   x:=xc;
   SpinEdit2.Value:=SpinEdit2.Value+1;
end;

procedure TForm1.Reset(Sender: TObject);
var i:Integer;
begin
  for i:=1 to n do x[i]:=0;
  xc:=x;
  NacteniZadani;
  SpinEdit2.Value:=0;
end;

procedure TForm1.PuvSoust(Sender: TObject);
var i,j,Chyba :Integer;
    Vypis:String;
begin
 For i:=1 to n do
   For j:=1 to n do
     begin
       Val(Form1.StringGridPuvA.Cells[j-1,i-1],PuvA[i,j],Chyba);
     end;
 For i:=1 to n do
     begin
       Val(Form1.StringGridPuvb.Cells[0,i-1],PuvB[i],Chyba);
     end;

  for i:=1 to n do
  begin
    for j:=1 to n do a[i,j]:=-puvA[i,j]/PuvA[i,i];
    b[i]:=Puvb[i]/Puva[i,i];
  end;
  for i:=1 to n do a[i,i]:=0;
  for i:=1 to n do
  begin
     for j:=1 to n do
             begin
                  Str(a[i,j]:7:6,Vypis);
                  StringGridA.Cells[j-1,i-1]:=vypis;
             end;
   Str(b[i]:7:6,Vypis);
   StringGridB.Cells[0,i-1]:=vypis;
  end;
end;

procedure TForm1.Transponovana(Sender: TObject);
var i,j,k,chyba :Integer;
    Vypis:String;
    at,ata: array [1..Max,1..Max] of double;
    atb    : array [1..Max]       of double;
begin

  For i:=1 to n do
   For j:=1 to n do
     begin
       Val(Form1.StringGridPuvA.Cells[j-1,i-1],PuvA[i,j],Chyba);
     end;
 For i:=1 to n do
     begin
       Val(Form1.StringGridPuvb.Cells[0,i-1],PuvB[i],Chyba);
     end;

 for i:=1 to n do
   for j:=1 to n do  at[i,j]:=puvA[j,i];

 for i:=1 to n do
   for j:=1 to n do  ata[i,j]:=0;

 for i:=1 to n do
   for j:=1 to n do
     for k:=1 to n do
        ata[i,j]:=ata[i,j]+at[i,k]*PuvA[k,j];

  for i:=1 to n do atb[i]:=0;

   for i:=1 to n do
     for j:=1 to n do atb[i]:=atb[i]+ at[i,j]*PuvB[j];

  for i:=1 to n do
  begin
    for j:=1 to n do a[i,j]:=-ATA[i,j]/ATA[i,i];
    b[i]:=ATB[i]/ATA[i,i];
  end;
  for i:=1 to n do a[i,i]:=0;
  for i:=1 to n do
  begin
     for j:=1 to n do
             begin
                  Str(a[i,j]:7:6,Vypis);
                  StringGridA.Cells[j-1,i-1]:=vypis;
             end;
   Str(b[i]:7:6,Vypis);
   StringGridB.Cells[0,i-1]:=vypis;
  end;
end;

end.
